commit fa92e118453b036b60b20ff1f703687f4d63af77
Author: Romain Tartière <romain@blogreen.org>
Date:   Fri Sep 17 15:35:39 2021 -1000

    Pet rubocop

diff --git a/spec/classes/ip_nat_spec.rb b/spec/classes/ip_nat_spec.rb
index e8389ef..fb89c30 100644
--- a/spec/classes/ip_nat_spec.rb
+++ b/spec/classes/ip_nat_spec.rb
@@ -15,7 +15,7 @@ describe 'nftables' do
           ensure: 'present',
           owner:  'root',
           group:  'root',
-          mode:   '0640',
+          mode:   '0640'
         )
       }
 
@@ -23,7 +23,7 @@ describe 'nftables' do
         is_expected.to contain_concat__fragment('nftables-ip-nat-header').with(
           target:  'nftables-ip-nat',
           content: %r{^table ip nat \{$},
-          order:   '00',
+          order:   '00'
         )
       }
 
@@ -31,7 +31,7 @@ describe 'nftables' do
         is_expected.to contain_concat__fragment('nftables-ip-nat-body').with(
           target:  'nftables-ip-nat',
           content: %r{^\s+include "ip-nat-chain-\*\.nft"$},
-          order:   '98',
+          order:   '98'
         )
       }
 
@@ -39,7 +39,7 @@ describe 'nftables' do
         is_expected.to contain_concat__fragment('nftables-ip-nat-footer').with(
           target:  'nftables-ip-nat',
           content: %r{^\}$},
-          order:   '99',
+          order:   '99'
         )
       }
 
@@ -49,7 +49,7 @@ describe 'nftables' do
           ensure: 'present',
           owner:  'root',
           group:  'root',
-          mode:   '0640',
+          mode:   '0640'
         )
       }
 
@@ -57,7 +57,7 @@ describe 'nftables' do
         is_expected.to contain_concat__fragment('nftables-ip6-nat-header').with(
           target:  'nftables-ip6-nat',
           content: %r{^table ip6 nat \{$},
-          order:   '00',
+          order:   '00'
         )
       }
 
@@ -65,7 +65,7 @@ describe 'nftables' do
         is_expected.to contain_concat__fragment('nftables-ip6-nat-body').with(
           target:  'nftables-ip6-nat',
           content: %r{^\s+include "ip6-nat-chain-\*\.nft"$},
-          order:   '98',
+          order:   '98'
         )
       }
 
@@ -73,7 +73,7 @@ describe 'nftables' do
         is_expected.to contain_concat__fragment('nftables-ip6-nat-footer').with(
           target:  'nftables-ip6-nat',
           content: %r{^\}$},
-          order:   '99',
+          order:   '99'
         )
       }
 
@@ -84,35 +84,35 @@ describe 'nftables' do
             owner:          'root',
             group:          'root',
             mode:           '0640',
-            ensure_newline: true,
+            ensure_newline: true
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip-nat-chain-PREROUTING-header').with(
             target:  'nftables-ip-nat-chain-PREROUTING',
             content: %r{^chain PREROUTING \{$},
-            order:   '00',
+            order:   '00'
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip-nat-chain-PREROUTING-rule-type').with(
             target:  'nftables-ip-nat-chain-PREROUTING',
             content: %r{^  type nat hook prerouting priority -100$},
-            order:   '01-nftables-ip-nat-chain-PREROUTING-rule-type-b',
+            order:   '01-nftables-ip-nat-chain-PREROUTING-rule-type-b'
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip-nat-chain-PREROUTING-rule-policy').with(
             target:  'nftables-ip-nat-chain-PREROUTING',
             content: %r{^  policy accept$},
-            order:   '02-nftables-ip-nat-chain-PREROUTING-rule-policy-b',
+            order:   '02-nftables-ip-nat-chain-PREROUTING-rule-policy-b'
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip-nat-chain-PREROUTING-footer').with(
             target:  'nftables-ip-nat-chain-PREROUTING',
             content: %r{^\}$},
-            order:   '99',
+            order:   '99'
           )
         }
       end
@@ -124,35 +124,35 @@ describe 'nftables' do
             owner:          'root',
             group:          'root',
             mode:           '0640',
-            ensure_newline: true,
+            ensure_newline: true
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip-nat-chain-POSTROUTING-header').with(
             target:  'nftables-ip-nat-chain-POSTROUTING',
             content: %r{^chain POSTROUTING \{$},
-            order:   '00',
+            order:   '00'
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip-nat-chain-POSTROUTING-rule-type').with(
             target:  'nftables-ip-nat-chain-POSTROUTING',
             content: %r{^  type nat hook postrouting priority 100$},
-            order:   '01-nftables-ip-nat-chain-POSTROUTING-rule-type-b',
+            order:   '01-nftables-ip-nat-chain-POSTROUTING-rule-type-b'
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip-nat-chain-POSTROUTING-rule-policy').with(
             target:  'nftables-ip-nat-chain-POSTROUTING',
             content: %r{^  policy accept$},
-            order:   '02-nftables-ip-nat-chain-POSTROUTING-rule-policy-b',
+            order:   '02-nftables-ip-nat-chain-POSTROUTING-rule-policy-b'
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip-nat-chain-POSTROUTING-footer').with(
             target:  'nftables-ip-nat-chain-POSTROUTING',
             content: %r{^\}$},
-            order:   '99',
+            order:   '99'
           )
         }
       end
@@ -164,35 +164,35 @@ describe 'nftables' do
             owner:          'root',
             group:          'root',
             mode:           '0640',
-            ensure_newline: true,
+            ensure_newline: true
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip6-nat-chain-PREROUTING6-header').with(
             target:  'nftables-ip6-nat-chain-PREROUTING6',
             content: %r{^chain PREROUTING6 \{$},
-            order:   '00',
+            order:   '00'
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip6-nat-chain-PREROUTING6-rule-type').with(
             target:  'nftables-ip6-nat-chain-PREROUTING6',
             content: %r{^  type nat hook prerouting priority -100$},
-            order:   '01-nftables-ip6-nat-chain-PREROUTING6-rule-type-b',
+            order:   '01-nftables-ip6-nat-chain-PREROUTING6-rule-type-b'
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip6-nat-chain-PREROUTING6-rule-policy').with(
             target:  'nftables-ip6-nat-chain-PREROUTING6',
             content: %r{^  policy accept$},
-            order:   '02-nftables-ip6-nat-chain-PREROUTING6-rule-policy-b',
+            order:   '02-nftables-ip6-nat-chain-PREROUTING6-rule-policy-b'
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip6-nat-chain-PREROUTING6-footer').with(
             target:  'nftables-ip6-nat-chain-PREROUTING6',
             content: %r{^\}$},
-            order:   '99',
+            order:   '99'
           )
         }
       end
@@ -204,35 +204,35 @@ describe 'nftables' do
             owner:          'root',
             group:          'root',
             mode:           '0640',
-            ensure_newline: true,
+            ensure_newline: true
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip6-nat-chain-POSTROUTING6-header').with(
             target:  'nftables-ip6-nat-chain-POSTROUTING6',
             content: %r{^chain POSTROUTING6 \{$},
-            order:   '00',
+            order:   '00'
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip6-nat-chain-POSTROUTING6-rule-type').with(
             target:  'nftables-ip6-nat-chain-POSTROUTING6',
             content: %r{^  type nat hook postrouting priority 100$},
-            order:   '01-nftables-ip6-nat-chain-POSTROUTING6-rule-type-b',
+            order:   '01-nftables-ip6-nat-chain-POSTROUTING6-rule-type-b'
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip6-nat-chain-POSTROUTING6-rule-policy').with(
             target:  'nftables-ip6-nat-chain-POSTROUTING6',
             content: %r{^  policy accept$},
-            order:   '02-nftables-ip6-nat-chain-POSTROUTING6-rule-policy-b',
+            order:   '02-nftables-ip6-nat-chain-POSTROUTING6-rule-policy-b'
           )
         }
         it {
           is_expected.to contain_concat__fragment('nftables-ip6-nat-chain-POSTROUTING6-footer').with(
             target:  'nftables-ip6-nat-chain-POSTROUTING6',
             content: %r{^\}$},
-            order:   '99',
+            order:   '99'
           )
         }
       end
@@ -251,7 +251,7 @@ describe 'nftables' do
             ensure: 'present',
             owner:  'root',
             group:  'root',
-            mode:   '0640',
+            mode:   '0640'
           )
         }
       end