commit fa92e118453b036b60b20ff1f703687f4d63af77
Author: Romain Tartière <romain@blogreen.org>
Date:   Fri Sep 17 15:35:39 2021 -1000

    Pet rubocop

diff --git a/spec/defines/rule_spec.rb b/spec/defines/rule_spec.rb
index c3a5281..5e44c4c 100644
--- a/spec/defines/rule_spec.rb
+++ b/spec/defines/rule_spec.rb
@@ -40,14 +40,14 @@ describe 'nftables::rule' do
             is_expected.to contain_concat__fragment('nftables-inet-filter-chain-CHAIN_NAME-rule-RULE_header').with(
               order: '50-nftables-inet-filter-chain-CHAIN_NAME-rule-RULE-a',
               target: 'nftables-inet-filter-chain-CHAIN_NAME',
-              content: %r{^#.*$},
+              content: %r{^#.*$}
             )
           }
           it {
             is_expected.to contain_concat__fragment('nftables-inet-filter-chain-CHAIN_NAME-rule-RULE').with(
               order: '50-nftables-inet-filter-chain-CHAIN_NAME-rule-RULE-b',
               target: 'nftables-inet-filter-chain-CHAIN_NAME',
-              content: '  port 22 allow',
+              content: '  port 22 allow'
             )
           }
           context 'with optional parameters set' do
@@ -60,7 +60,7 @@ describe 'nftables::rule' do
               is_expected.to contain_concat__fragment('nftables-TABLE-chain-CHAIN_NAME-rule-RULE_header').with(
                 order: '85-nftables-TABLE-chain-CHAIN_NAME-rule-RULE-a',
                 target: 'nftables-TABLE-chain-CHAIN_NAME',
-                content: %r{^#.*$},
+                content: %r{^#.*$}
               )
             }
             it { is_expected.to contain_concat__fragment('nftables-TABLE-chain-CHAIN_NAME-rule-RULE') }
@@ -68,7 +68,7 @@ describe 'nftables::rule' do
               is_expected.to contain_concat__fragment('nftables-TABLE-chain-CHAIN_NAME-rule-RULE').with(
                 order: '85-nftables-TABLE-chain-CHAIN_NAME-rule-RULE-b',
                 target: 'nftables-TABLE-chain-CHAIN_NAME',
-                content: '  port 22 allow',
+                content: '  port 22 allow'
               )
             }
           end
@@ -87,14 +87,14 @@ describe 'nftables::rule' do
             is_expected.to contain_concat__fragment('nftables-inet-filter-chain-CHAIN_NAME-rule-RULE_header').with(
               order: '50-nftables-inet-filter-chain-CHAIN_NAME-rule-RULE-a',
               target: 'nftables-inet-filter-chain-CHAIN_NAME',
-              content: %r{^#.*$},
+              content: %r{^#.*$}
             )
           }
           it {
             is_expected.to contain_concat__fragment('nftables-inet-filter-chain-CHAIN_NAME-rule-RULE').with(
               order: '50-nftables-inet-filter-chain-CHAIN_NAME-rule-RULE-b',
               target: 'nftables-inet-filter-chain-CHAIN_NAME',
-              source: 'puppet:///modules/foo/bar',
+              source: 'puppet:///modules/foo/bar'
             )
           }
           context 'with optional parameters set' do
@@ -107,7 +107,7 @@ describe 'nftables::rule' do
               is_expected.to contain_concat__fragment('nftables-TABLE-chain-CHAIN_NAME-rule-RULE_header').with(
                 order: '85-nftables-TABLE-chain-CHAIN_NAME-rule-RULE-a',
                 target: 'nftables-TABLE-chain-CHAIN_NAME',
-                content: %r{^#.*$},
+                content: %r{^#.*$}
               )
             }
             it { is_expected.to contain_concat__fragment('nftables-TABLE-chain-CHAIN_NAME-rule-RULE') }
@@ -115,7 +115,7 @@ describe 'nftables::rule' do
               is_expected.to contain_concat__fragment('nftables-TABLE-chain-CHAIN_NAME-rule-RULE').with(
                 order: '85-nftables-TABLE-chain-CHAIN_NAME-rule-RULE-b',
                 target: 'nftables-TABLE-chain-CHAIN_NAME',
-                source: 'puppet:///modules/foo/bar',
+                source: 'puppet:///modules/foo/bar'
               )
             }
           end
@@ -138,14 +138,14 @@ describe 'nftables::rule' do
             is_expected.to contain_concat__fragment('nftables-inet-filter-chain-CHAIN_NAME-rule-RULE-22_header').with(
               order: '50-nftables-inet-filter-chain-CHAIN_NAME-rule-RULE-22-a',
               target: 'nftables-inet-filter-chain-CHAIN_NAME',
-              content: %r{^#.*$},
+              content: %r{^#.*$}
             )
           }
           it {
             is_expected.to contain_concat__fragment('nftables-inet-filter-chain-CHAIN_NAME-rule-RULE-22').with(
               order: '50-nftables-inet-filter-chain-CHAIN_NAME-rule-RULE-22-b',
               target: 'nftables-inet-filter-chain-CHAIN_NAME',
-              content: '  port 22 allow',
+              content: '  port 22 allow'
             )
           }
         end